import qualified Sound.ALSA.Sequencer.Address as Addr
import qualified Sound.ALSA.Sequencer.Client as Client
import qualified Sound.ALSA.Sequencer.Port as Port
import qualified Sound.ALSA.Sequencer.Event as Event
import qualified Sound.ALSA.Sequencer as SndSeq
import qualified Sound.ALSA.Exception as AlsaExc

main :: IO ()
main = (do
  putStrLn "Starting."
  SndSeq.with SndSeq.defaultName SndSeq.Block $ \h -> do
  Client.setName (h :: SndSeq.T SndSeq.OutputMode) "Haskell-Broadcast"
  c <- Client.getId h
  putStrLn ("Created sequencer with id: " ++ show c)
  -- tgt_addr <- Addr.parse h "HS1:255"
  let tgt_addr = Addr.Cons Client.broadcast Port.unknown
  print tgt_addr
  let ev n =
         (Event.simple
            (Addr.Cons c Port.unknown)
            (Event.NoteEv n $ Event.simpleNote 0 60 64))
         {Event.dest = tgt_addr}
  _ <- Event.outputDirect h $ ev Event.NoteOn
  _ <- getChar
  _ <- Event.outputDirect h $ ev Event.NoteOff
  return ())
  `AlsaExc.catch` \e ->
     putStrLn $ "alsa_exception: " ++ AlsaExc.show e
